'           ISAM Include File For IBM BASCOM 3.0
'           (C) Copyright 1984, 1987 by Microsoft
'

TYPE RecordDescriptor

	nFields 	as INTEGER	'Number of Fields
	flags		as INTEGER	'Record flags
	minAllocation	as INTEGER	'Mininum Allocation

END TYPE

TYPE FieldDescriptor

	fName		as STRING * 20	'Name of field
	dType		as INTEGER	'Data type
	Segment 	as INTEGER	'Segment #, usually 1
	Position	as INTEGER	'Byte offset
	Length		as INTEGER	'Length of Key
	Handle		as INTEGER	'Reference number of key field
	Flags		as INTEGER	'Flags1
	reserved	as INTEGER	'Not Used
END TYPE

Declare Function IXstat%
Declare Function MICreate%(Seg fileNam as String, _
			   Seg Record as RecordDescriptor, _
			   Seg Keys as FieldDescriptor)

Declare Function MIOpen%(Seg fileNam as String, ByVal Mode as Integer)
Declare Function MIClose%(ByVal File as Integer)

Declare Function MIRead%(ByVal File as Integer, _
			 Seg aRecord as Any, _
			 ByVal size as Integer)
Declare Function MIDread%(ByVal File as Integer, _
			  Seg aRecord as Any, _
			  ByVal size as Integer, _
			  Seg dataPointer as Long)
Declare Function MIGetdp%(ByVal File as Integer, _
			  Seg dataPointer as Long)

Declare Function MIWrite%(ByVal File as Integer, _
			  Seg aRecord as Any, _
			  ByVal size as Integer)
Declare Function MIReWrite%(ByVal File as Integer, _
			    Seg aRecord as Any, _
			    ByVal size as Integer)

Declare Function MIDelete%(ByVal File as Integer)

Declare Function MISeek%(ByVal File as Integer, _
			 ByVal keyNumber as Integer, _
			 Seg aKey as Any, _
			 ByVal size as Integer, _
			 ByVal Mode as Integer)
Declare Function MISSeek%(ByVal File as Integer, _
			  ByVal keyNumber as Integer, _
			  aStringKey as String, _
			  ByVal Mode as Integer)

Declare Function MINext%(ByVal File as Integer, _
			 ByVal keyNumber as Integer)
Declare Function MIPrev%(ByVal File as Integer, _
			 ByVal keyNumber as Integer)

Declare Function MISavefp%(ByVal File as Integer)
Declare Function MIRestorefp%(ByVal File as Integer)

Declare Function MISizeof%(ByVal File as Integer)

Declare Function MILock%(ByVal File as Integer, _
			 ByVal request as Integer)

Declare Function MIGetkd%(ByVal File as Integer, _
			  ByVal keyNumber as Integer, _
			  ByVal keySplitNumber as Integer, _
			  Seg aKey as FieldDescriptor)

Declare Function MIControl%(ByVal request as Integer, _
			    Seg parameter as Any)

' Data Types for dType Field in Key Descripture

IT.INTEGER% = 1
IT.STRING%  = 5
IT.LONG%  = 14
IT.SINGLE%  = 8
IT.DOUBLE%  = 11

' field types for "FLAGS" in Key Descripture

IF.DATA% = 0		' one of
IF.KEY% = 1
IF.SPLITKEY% = 2

IF.DUPS% = 256		' or'ed in with one or more of
IF.DESCEND% = 512
IF.NOTCASE% = 1024

' Open Modes for MIopen

IO.READ% = 0
IO.UPDATE% = 2
IO.MU.READ% = 4
IO.MU.UPDATE% = 5
IO.MU.SINGLE.UP% = 7
IO.MU.NO.UP% = 8

' Seek Modes for MIseek

IS.FIRST% = 0
IS.LAST%  = 1
IS.EQUAL% = 2
IS.GREATER% = 3
IS.NOT.LESS% = 4
IS.EQ.FIRST% = 5


' Lock Requests for MIlock

IL.AUTO% = 0
IL.MANUAL% = 1
IL.WAIT% = 2
IL.NOWAIT% = 3
IL.RELEASE% = 4
IL.LOCK% = 5
IL.RELEASE.CUR% = 6
